/* utils.c generated by valac 0.36.4, the Vala compiler
 * generated from utils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2016 Deepin, Inc.
 *               2011 ~ 2016 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <glib/gstdio.h>
#include <libsecret/secret.h>

#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))



gchar* project_path (void);
gchar* font_match (const gchar* family);
gchar** list_mono_or_dot_fonts (gint* num, int* result_length1);
void utils_hex_to_rgba (const gchar* hex_color, gdouble alpha, GdkRGBA* result);
void utils_set_context_color (cairo_t* cr, GdkRGBA* color);
void utils_propagate_draw (GtkContainer* widget, cairo_t* cr);
gboolean utils_is_light_color (const gchar* color_string);
gdouble utils_get_color_brightness (const gchar* color_string);
void utils_touch_dir (const gchar* dir);
void utils_create_file (const gchar* file_path);
GeeArrayList* utils_list_files (const gchar* path);
void utils_remove_all_children (GtkContainer* container);
void utils_destroy_all_children (GtkContainer* container);
void utils_get_origin_allocation (GtkWidget* w, GtkAllocation* result);
gboolean utils_move_window (GtkWidget* widget, GdkEventButton* event, GtkWindow* window);
gboolean utils_is_left_button (GdkEventButton* event);
void utils_toggle_max_window (GtkWindow* window);
gboolean utils_is_right_button (GdkEventButton* event);
gboolean utils_is_double_click (GdkEventButton* event);
void utils_load_css_theme (const gchar* css_path);
gchar* utils_slice_string (const gchar* str, gint unichar_num);
gboolean utils_is_command_exist (const gchar* command_name);
gchar* utils_get_command_output (const gchar* cmd);
gchar* utils_get_proc_file_content (const gchar* proc_file_path);
gchar* utils_get_image_path (const gchar* image_name);
gchar* utils_get_theme_path (const gchar* theme_name);
gchar* utils_get_theme_dir (void);
gchar* utils_get_root_path (const gchar* file_path);
gchar* utils_get_config_dir (void);
gchar* utils_get_config_file_path (const gchar* config_name);
gchar* utils_get_ssh_script_path (void);
gchar* utils_get_default_private_key_path (void);
gchar* utils_lookup_password (const gchar* user, const gchar* server_address, const gchar* port);
void utils_store_password (const gchar* user, const gchar* server_address, gint port, const gchar* password);
static void _g_free0_ (gpointer var);
static void __lambda6_ (GObject* obj, GAsyncResult* async_res);
static void ___lambda6__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
void utils_get_pointer_position (gint* x, gint* y);
gboolean utils_pointer_in_widget_area (GtkWidget* widget);
void utils_show_manual (void);
void utils_write_log (const gchar* log);
cairo_surface_t* utils_create_image_surface (const gchar* surface_path);
gint utils_get_active_monitor (GdkScreen* screen);
gint utils_get_pointer_monitor (GdkScreen* screen);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void utils_hex_to_rgba (const gchar* hex_color, gdouble alpha, GdkRGBA* result) {
	GdkRGBA rgba_color = {0};
	const gchar* _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (hex_color != NULL);
	memset (&rgba_color, 0, sizeof (GdkRGBA));
	_tmp0_ = hex_color;
	gdk_rgba_parse (&rgba_color, _tmp0_);
	_tmp1_ = alpha;
	rgba_color.alpha = _tmp1_;
	*result = rgba_color;
	return;
}


void utils_set_context_color (cairo_t* cr, GdkRGBA* color) {
	cairo_t* _tmp0_;
	GdkRGBA _tmp1_;
	gdouble _tmp2_;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
	g_return_if_fail (cr != NULL);
	g_return_if_fail (color != NULL);
	_tmp0_ = cr;
	_tmp1_ = *color;
	_tmp2_ = _tmp1_.red;
	_tmp3_ = *color;
	_tmp4_ = _tmp3_.green;
	_tmp5_ = *color;
	_tmp6_ = _tmp5_.blue;
	_tmp7_ = *color;
	_tmp8_ = _tmp7_.alpha;
	cairo_set_source_rgba (_tmp0_, _tmp2_, _tmp4_, _tmp6_, _tmp8_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void utils_propagate_draw (GtkContainer* widget, cairo_t* cr) {
	GtkContainer* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (widget != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = widget;
	_tmp1_ = gtk_container_get_children (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_);
	_tmp4_ = _tmp3_ > ((guint) 0);
	_g_list_free0 (_tmp2_);
	if (_tmp4_) {
		GtkContainer* _tmp5_;
		GList* _tmp6_;
		_tmp5_ = widget;
		_tmp6_ = gtk_container_get_children (_tmp5_);
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
			child_collection = _tmp6_;
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
				GtkWidget* _tmp7_;
				GtkWidget* child = NULL;
				_tmp7_ = _g_object_ref0 ((GtkWidget*) child_it->data);
				child = _tmp7_;
				{
					GtkContainer* _tmp8_;
					GtkWidget* _tmp9_;
					cairo_t* _tmp10_;
					_tmp8_ = widget;
					_tmp9_ = child;
					_tmp10_ = cr;
					gtk_container_propagate_draw (_tmp8_, _tmp9_, _tmp10_);
					_g_object_unref0 (child);
				}
			}
			_g_list_free0 (child_collection);
		}
	}
}


gboolean utils_is_light_color (const gchar* color_string) {
	gboolean result = FALSE;
	GdkRGBA color = {0};
	const gchar* _tmp0_;
	gdouble r = 0.0;
	GdkRGBA _tmp1_;
	gdouble _tmp2_;
	gdouble g = 0.0;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	gdouble b = 0.0;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	gdouble max_v = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble min_v = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble s = 0.0;
	gdouble _tmp17_;
	gdouble _tmp20_;
	gboolean _tmp21_ = FALSE;
	gdouble _tmp22_;
	g_return_val_if_fail (color_string != NULL, FALSE);
	memset (&color, 0, sizeof (GdkRGBA));
	_tmp0_ = color_string;
	gdk_rgba_parse (&color, _tmp0_);
	_tmp1_ = color;
	_tmp2_ = _tmp1_.red;
	r = _tmp2_;
	_tmp3_ = color;
	_tmp4_ = _tmp3_.green;
	g = _tmp4_;
	_tmp5_ = color;
	_tmp6_ = _tmp5_.blue;
	b = _tmp6_;
	_tmp7_ = r;
	_tmp8_ = g;
	_tmp9_ = b;
	_tmp10_ = MAX (_tmp8_, _tmp9_);
	_tmp11_ = MAX (_tmp7_, _tmp10_);
	max_v = _tmp11_;
	_tmp12_ = r;
	_tmp13_ = g;
	_tmp14_ = b;
	_tmp15_ = MIN (_tmp13_, _tmp14_);
	_tmp16_ = MIN (_tmp12_, _tmp15_);
	min_v = _tmp16_;
	_tmp17_ = max_v;
	if (_tmp17_ == ((gdouble) 0)) {
		s = 0.0;
	} else {
		gdouble _tmp18_;
		gdouble _tmp19_;
		_tmp18_ = min_v;
		_tmp19_ = max_v;
		s = 1.0 - (_tmp18_ / _tmp19_);
	}
	_tmp20_ = max_v;
	b = _tmp20_;
	_tmp22_ = b;
	if (_tmp22_ > 0.35) {
		gdouble _tmp23_;
		_tmp23_ = s;
		_tmp21_ = _tmp23_ < 0.7;
	} else {
		_tmp21_ = FALSE;
	}
	result = _tmp21_;
	return result;
}


gdouble utils_get_color_brightness (const gchar* color_string) {
	gdouble result = 0.0;
	GdkRGBA color = {0};
	const gchar* _tmp0_;
	gdouble r = 0.0;
	GdkRGBA _tmp1_;
	gdouble _tmp2_;
	gdouble g = 0.0;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	gdouble b = 0.0;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	gdouble max_v = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble min_v = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble s = 0.0;
	gdouble _tmp17_;
	gdouble _tmp20_;
	g_return_val_if_fail (color_string != NULL, 0.0);
	memset (&color, 0, sizeof (GdkRGBA));
	_tmp0_ = color_string;
	gdk_rgba_parse (&color, _tmp0_);
	_tmp1_ = color;
	_tmp2_ = _tmp1_.red;
	r = _tmp2_;
	_tmp3_ = color;
	_tmp4_ = _tmp3_.green;
	g = _tmp4_;
	_tmp5_ = color;
	_tmp6_ = _tmp5_.blue;
	b = _tmp6_;
	_tmp7_ = r;
	_tmp8_ = g;
	_tmp9_ = b;
	_tmp10_ = MAX (_tmp8_, _tmp9_);
	_tmp11_ = MAX (_tmp7_, _tmp10_);
	max_v = _tmp11_;
	_tmp12_ = r;
	_tmp13_ = g;
	_tmp14_ = b;
	_tmp15_ = MIN (_tmp13_, _tmp14_);
	_tmp16_ = MIN (_tmp12_, _tmp15_);
	min_v = _tmp16_;
	_tmp17_ = max_v;
	if (_tmp17_ == ((gdouble) 0)) {
		s = 0.0;
	} else {
		gdouble _tmp18_;
		gdouble _tmp19_;
		_tmp18_ = min_v;
		_tmp19_ = max_v;
		s = 1.0 - (_tmp18_ / _tmp19_);
	}
	_tmp20_ = max_v;
	b = _tmp20_;
	result = b;
	return result;
}


void utils_touch_dir (const gchar* dir) {
	GFile* dir_file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (dir != NULL);
	_tmp0_ = dir;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	dir_file = _tmp1_;
	_tmp2_ = dir_file;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (!_tmp3_) {
		{
			GFile* _tmp4_;
			_tmp4_ = dir_file;
			g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch13_g_error;
			}
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* err = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp5_ = err;
			_tmp6_ = _tmp5_->message;
			g_print ("Could not create dir: %s\n", _tmp6_);
			_g_error_free0 (err);
		}
		__finally13:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (dir_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (dir_file);
}


void utils_create_file (const gchar* file_path) {
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (file_path != NULL);
	_tmp0_ = file_path;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	file = _tmp1_;
	_tmp2_ = file;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (!_tmp3_) {
		{
			GFile* _tmp4_;
			GFileOutputStream* _tmp5_;
			GFileOutputStream* _tmp6_;
			_tmp4_ = file;
			_tmp5_ = g_file_create (_tmp4_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
			_tmp6_ = _tmp5_;
			_g_object_unref0 (_tmp6_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch14_g_error;
			}
		}
		goto __finally14;
		__catch14_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_print ("create_file: %s\n", _tmp8_);
			_g_error_free0 (e);
		}
		__finally14:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (file);
}


GeeArrayList* utils_list_files (const gchar* path) {
	GeeArrayList* result = NULL;
	GeeArrayList* files = NULL;
	GeeArrayList* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	files = _tmp0_;
	{
		GFileEnumerator* enumerator = NULL;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileEnumerator* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileInfo* info = NULL;
		_tmp1_ = path;
		_tmp2_ = g_file_new_for_path (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_enumerate_children (_tmp3_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		enumerator = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch15_g_error;
		}
		info = NULL;
		while (TRUE) {
			GFileInfo* _tmp6_ = NULL;
			GFileEnumerator* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GFileType _tmp12_;
			_tmp7_ = enumerator;
			_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error_);
			_tmp6_ = _tmp8_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				goto __catch15_g_error;
			}
			_tmp9_ = _tmp6_;
			_tmp6_ = NULL;
			_g_object_unref0 (info);
			info = _tmp9_;
			_tmp10_ = info;
			if (!(_tmp10_ != NULL)) {
				_g_object_unref0 (_tmp6_);
				break;
			}
			_tmp11_ = info;
			_tmp12_ = g_file_info_get_file_type (_tmp11_);
			if (_tmp12_ != G_FILE_TYPE_DIRECTORY) {
				GeeArrayList* _tmp13_;
				GFileInfo* _tmp14_;
				const gchar* _tmp15_;
				_tmp13_ = files;
				_tmp14_ = info;
				_tmp15_ = g_file_info_get_name (_tmp14_);
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp15_);
			}
			_g_object_unref0 (_tmp6_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_print ("list_files: %s\n", _tmp17_);
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (files);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = files;
	return result;
}


void utils_remove_all_children (GtkContainer* container) {
	GtkContainer* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (container != NULL);
	_tmp0_ = container;
	_tmp1_ = gtk_container_get_children (_tmp0_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp1_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp2_;
			GtkWidget* w = NULL;
			_tmp2_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp2_;
			{
				GtkContainer* _tmp3_;
				GtkWidget* _tmp4_;
				_tmp3_ = container;
				_tmp4_ = w;
				gtk_container_remove (_tmp3_, _tmp4_);
				_g_object_unref0 (w);
			}
		}
		_g_list_free0 (w_collection);
	}
}


void utils_destroy_all_children (GtkContainer* container) {
	GtkContainer* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (container != NULL);
	_tmp0_ = container;
	_tmp1_ = gtk_container_get_children (_tmp0_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp1_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp2_;
			GtkWidget* w = NULL;
			_tmp2_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp2_;
			{
				GtkContainer* _tmp3_;
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				_tmp3_ = container;
				_tmp4_ = w;
				gtk_container_remove (_tmp3_, _tmp4_);
				_tmp5_ = w;
				gtk_widget_destroy (_tmp5_);
				_g_object_unref0 (w);
			}
		}
		_g_list_free0 (w_collection);
	}
}


void utils_get_origin_allocation (GtkWidget* w, GtkAllocation* result) {
	GtkAllocation alloc = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	alloc = _tmp1_;
	_tmp2_ = w;
	_tmp3_ = w;
	_tmp4_ = gtk_widget_get_toplevel (_tmp3_);
	gtk_widget_translate_coordinates (_tmp2_, _tmp4_, 0, 0, &_tmp5_, &_tmp6_);
	alloc.x = _tmp5_;
	alloc.y = _tmp6_;
	*result = alloc;
	return;
}


gboolean utils_move_window (GtkWidget* widget, GdkEventButton* event, GtkWindow* window) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (window != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = utils_is_left_button (_tmp0_);
	if (_tmp1_) {
		GtkWindow* _tmp2_;
		GdkEventButton* _tmp3_;
		guint _tmp4_;
		GdkEventButton* _tmp5_;
		gdouble _tmp6_;
		GdkEventButton* _tmp7_;
		gdouble _tmp8_;
		GdkEventButton* _tmp9_;
		guint32 _tmp10_;
		_tmp2_ = window;
		_tmp3_ = event;
		_tmp4_ = _tmp3_->button;
		_tmp5_ = event;
		_tmp6_ = _tmp5_->x_root;
		_tmp7_ = event;
		_tmp8_ = _tmp7_->y_root;
		_tmp9_ = event;
		_tmp10_ = _tmp9_->time;
		gtk_window_begin_move_drag (_tmp2_, (gint) _tmp4_, (gint) _tmp6_, (gint) _tmp8_, _tmp10_);
	}
	result = FALSE;
	return result;
}


void utils_toggle_max_window (GtkWindow* window) {
	GdkWindowState window_state = 0;
	GtkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindowState _tmp2_;
	GdkWindowState _tmp3_;
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _tmp0_);
	_tmp2_ = gdk_window_get_state (_tmp1_);
	window_state = _tmp2_;
	_tmp3_ = window_state;
	if ((_tmp3_ & GDK_WINDOW_STATE_MAXIMIZED) == GDK_WINDOW_STATE_MAXIMIZED) {
		GtkWindow* _tmp4_;
		_tmp4_ = window;
		gtk_window_unmaximize (_tmp4_);
	} else {
		GtkWindow* _tmp5_;
		_tmp5_ = window;
		gtk_window_maximize (_tmp5_);
	}
}


gboolean utils_is_left_button (GdkEventButton* event) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	guint _tmp1_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	result = _tmp1_ == ((guint) 1);
	return result;
}


gboolean utils_is_right_button (GdkEventButton* event) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	guint _tmp1_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	result = _tmp1_ == ((guint) 3);
	return result;
}


gboolean utils_is_double_click (GdkEventButton* event) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventButton* _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event;
	_tmp2_ = _tmp1_->button;
	if (_tmp2_ == ((guint) 1)) {
		GdkEventButton* _tmp3_;
		GdkEventType _tmp4_;
		_tmp3_ = event;
		_tmp4_ = _tmp3_->type;
		_tmp0_ = _tmp4_ == GDK_2BUTTON_PRESS;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void utils_load_css_theme (const gchar* css_path) {
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (css_path != NULL);
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	css_provider = _tmp2_;
	{
		const gchar* _tmp3_;
		_tmp3_ = css_path;
		gtk_css_provider_load_from_path (css_provider, _tmp3_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch16_g_error;
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_print ("Got error when load css: %s\n", _tmp5_);
		_g_error_free0 (e);
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (css_provider);
		_g_object_unref0 (screen);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_USER);
	_g_object_unref0 (css_provider);
	_g_object_unref0 (screen);
}


static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_;
	gunichar _tmp1_;
	gunichar _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = *index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	_vala_c = _tmp1_;
	_tmp2_ = _vala_c;
	if (_tmp2_ != ((gunichar) 0)) {
		gint _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = *index;
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
		*index = (gint) (_tmp4_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


gchar* utils_slice_string (const gchar* str, gint unichar_num) {
	gchar* result = NULL;
	gchar* slice_str = NULL;
	gchar* _tmp0_;
	gunichar c = 0U;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_strdup ("");
	slice_str = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp2_;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp1_) {
				}
				_tmp1_ = FALSE;
				_tmp2_ = str;
				_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
				c = _tmp3_;
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = i;
				_tmp6_ = unichar_num;
				if (_tmp5_ > _tmp6_) {
					const gchar* _tmp7_;
					gchar* _tmp8_;
					_tmp7_ = slice_str;
					_tmp8_ = g_strconcat (_tmp7_, "... ", NULL);
					result = _tmp8_;
					_g_free0 (slice_str);
					return result;
				} else {
					const gchar* _tmp9_;
					gunichar _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					_tmp9_ = slice_str;
					_tmp10_ = c;
					_tmp11_ = g_unichar_to_string (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = g_strconcat (_tmp9_, _tmp12_, NULL);
					_g_free0 (slice_str);
					slice_str = _tmp13_;
					_g_free0 (_tmp12_);
				}
			}
		}
	}
	result = slice_str;
	return result;
}


gboolean utils_is_command_exist (const gchar* command_name) {
	gboolean result = FALSE;
	gchar* paths = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	g_return_val_if_fail (command_name != NULL, FALSE);
	_tmp0_ = g_getenv ("PATH");
	_tmp1_ = g_strdup (_tmp0_);
	paths = _tmp1_;
	_tmp2_ = paths;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 0);
	{
		gchar** bin_path_collection = NULL;
		gint bin_path_collection_length1 = 0;
		gint _bin_path_collection_size_ = 0;
		gint bin_path_it = 0;
		bin_path_collection = _tmp4_;
		bin_path_collection_length1 = _vala_array_length (_tmp3_);
		for (bin_path_it = 0; bin_path_it < _vala_array_length (_tmp3_); bin_path_it = bin_path_it + 1) {
			gchar* _tmp5_;
			gchar* bin_path = NULL;
			_tmp5_ = g_strdup (bin_path_collection[bin_path_it]);
			bin_path = _tmp5_;
			{
				GFile* file = NULL;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
				gboolean _tmp13_;
				_tmp6_ = bin_path;
				_tmp7_ = command_name;
				_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp6_, _tmp7_, NULL);
				_tmp9_ = _tmp8_;
				_tmp10_ = g_file_new_for_path (_tmp9_);
				_tmp11_ = _tmp10_;
				_g_free0 (_tmp9_);
				file = _tmp11_;
				_tmp12_ = file;
				_tmp13_ = g_file_query_exists (_tmp12_, NULL);
				if (_tmp13_) {
					result = TRUE;
					_g_object_unref0 (file);
					_g_free0 (bin_path);
					bin_path_collection = (_vala_array_free (bin_path_collection, bin_path_collection_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (paths);
					return result;
				}
				_g_object_unref0 (file);
				_g_free0 (bin_path);
			}
		}
		bin_path_collection = (_vala_array_free (bin_path_collection, bin_path_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = FALSE;
	_g_free0 (paths);
	return result;
}


gchar* utils_get_command_output (const gchar* cmd) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (cmd != NULL, NULL);
	{
		gint exit_code = 0;
		gchar* std_out = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		_tmp0_ = cmd;
		g_spawn_command_line_sync (_tmp0_, &_tmp1_, NULL, &_tmp2_, &_inner_error_);
		_g_free0 (std_out);
		std_out = _tmp1_;
		exit_code = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (std_out);
			goto __catch17_g_error;
		}
		result = std_out;
		return result;
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		_g_error_free0 (e);
		return result;
	}
	__finally17:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


gchar* utils_get_proc_file_content (const gchar* proc_file_path) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (proc_file_path != NULL, NULL);
	{
		guint8* data = NULL;
		gint data_length1 = 0;
		gint _data_size_ = 0;
		const gchar* _tmp0_;
		guint8* _tmp1_ = NULL;
		size_t _tmp2_;
		guint8* _tmp3_;
		gint _tmp3__length1;
		_tmp0_ = proc_file_path;
		g_file_get_contents (_tmp0_, (gchar**) (&_tmp1_), &_tmp2_, &_inner_error_);
		data = (g_free (data), NULL);
		data = _tmp1_;
		data_length1 = _tmp2_;
		_data_size_ = data_length1;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			data = (g_free (data), NULL);
			goto __catch18_g_error;
		}
		_tmp3_ = data;
		_tmp3__length1 = data_length1;
		if (_tmp3_ != NULL) {
			guint8* _tmp14_;
			gint _tmp14__length1;
			gchar* _tmp15_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp4_ = FALSE;
					_tmp4_ = TRUE;
					while (TRUE) {
						gint _tmp6_;
						guint8* _tmp7_;
						gint _tmp7__length1;
						guint8* _tmp8_;
						gint _tmp8__length1;
						gint _tmp9_;
						guint8 _tmp10_;
						if (!_tmp4_) {
							gint _tmp5_;
							_tmp5_ = i;
							i = _tmp5_ + 1;
						}
						_tmp4_ = FALSE;
						_tmp6_ = i;
						_tmp7_ = data;
						_tmp7__length1 = data_length1;
						if (!(_tmp6_ < (_tmp7__length1 - 1))) {
							break;
						}
						_tmp8_ = data;
						_tmp8__length1 = data_length1;
						_tmp9_ = i;
						_tmp10_ = _tmp8_[_tmp9_];
						if (((gint) _tmp10_) == 0) {
							guint8* _tmp11_;
							gint _tmp11__length1;
							gint _tmp12_;
							guint8 _tmp13_;
							_tmp11_ = data;
							_tmp11__length1 = data_length1;
							_tmp12_ = i;
							_tmp11_[_tmp12_] = (guint8) ' ';
							_tmp13_ = _tmp11_[_tmp12_];
						}
					}
				}
			}
			_tmp14_ = data;
			_tmp14__length1 = data_length1;
			_tmp15_ = g_strdup ((const gchar*) _tmp14_);
			result = _tmp15_;
			data = (g_free (data), NULL);
			return result;
		} else {
			gchar* _tmp16_;
			_tmp16_ = g_strdup ("");
			result = _tmp16_;
			data = (g_free (data), NULL);
			return result;
		}
		data = (g_free (data), NULL);
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_print ("get_proc_file_content: %s\n", _tmp18_);
		_tmp19_ = g_strdup ("");
		result = _tmp19_;
		_g_error_free0 (e);
		return result;
	}
	__finally18:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


gchar* utils_get_image_path (const gchar* image_name) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (image_name != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = image_name;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "image", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp2_);
	result = _tmp5_;
	return result;
}


gchar* utils_get_theme_path (const gchar* theme_name) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (theme_name != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = theme_name;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "theme", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp2_);
	result = _tmp5_;
	return result;
}


gchar* utils_get_theme_dir (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "theme", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar* utils_get_root_path (const gchar* file_path) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (file_path != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = file_path;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp2_);
	result = _tmp5_;
	return result;
}


gchar* utils_get_config_dir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", NULL);
	result = _tmp1_;
	return result;
}


gchar* utils_get_config_file_path (const gchar* config_name) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (config_name != NULL, NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = config_name;
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", _tmp1_, NULL);
	result = _tmp2_;
	return result;
}


gchar* utils_get_ssh_script_path (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "ssh_login.sh", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar* utils_get_default_private_key_path (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_home_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, ".ssh", "id_rsa", NULL);
	result = _tmp1_;
	return result;
}


gchar* utils_lookup_password (const gchar* user, const gchar* server_address, const gchar* port) {
	gchar* result = NULL;
	SecretSchema* password_schema = NULL;
	const gchar* _tmp0_;
	gchar* password = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (user != NULL, NULL);
	g_return_val_if_fail (server_address != NULL, NULL);
	_tmp0_ = port;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		SecretSchema* _tmp5_;
		_tmp1_ = user;
		_tmp2_ = server_address;
		_tmp3_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s", _tmp1_, _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = secret_schema_new (_tmp4_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
		_secret_schema_unref0 (password_schema);
		password_schema = _tmp5_;
		_g_free0 (_tmp4_);
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		SecretSchema* _tmp11_;
		_tmp6_ = user;
		_tmp7_ = server_address;
		_tmp8_ = port;
		_tmp9_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s.%s", _tmp6_, _tmp7_, _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = secret_schema_new (_tmp10_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
		_secret_schema_unref0 (password_schema);
		password_schema = _tmp11_;
		_g_free0 (_tmp10_);
	}
	{
		gchar* _tmp12_ = NULL;
		SecretSchema* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp13_ = password_schema;
		_tmp14_ = secret_password_lookup_sync (_tmp13_, NULL, &_inner_error_, NULL, "number", 8, "string", "eight", "even", TRUE, NULL);
		_tmp12_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch19_g_error;
		}
		_tmp15_ = _tmp12_;
		_tmp12_ = NULL;
		_g_free0 (password);
		password = _tmp15_;
		_g_free0 (_tmp12_);
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp16_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = e->message;
		g_error ("utils.vala:323: %s", _tmp16_);
		_g_error_free0 (e);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (password);
		_secret_schema_unref0 (password_schema);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (password == NULL) {
		gchar* _tmp17_;
		_tmp17_ = g_strdup ("");
		result = _tmp17_;
		_g_free0 (password);
		_secret_schema_unref0 (password_schema);
		return result;
	} else {
		result = password;
		_secret_schema_unref0 (password_schema);
		return result;
	}
	_g_free0 (password);
	_secret_schema_unref0 (password_schema);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void __lambda6_ (GObject* obj, GAsyncResult* async_res) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (async_res != NULL);
	{
		GAsyncResult* _tmp0_;
		_tmp0_ = async_res;
		secret_password_store_finish (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_print ("%s", _tmp2_);
		_g_error_free0 (e);
		return;
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda6__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda6_ (source_object, res);
}


void utils_store_password (const gchar* user, const gchar* server_address, gint port, const gchar* password) {
	SecretSchema* password_schema = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SecretSchema* _tmp5_;
	SecretSchema* _tmp6_;
	GHashTable* attributes = NULL;
	GHashTable* _tmp7_;
	GHashTable* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GHashTable* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	SecretSchema* _tmp20_;
	GHashTable* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (user != NULL);
	g_return_if_fail (server_address != NULL);
	g_return_if_fail (password != NULL);
	_tmp0_ = user;
	_tmp1_ = server_address;
	_tmp2_ = port;
	_tmp3_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s.%i", _tmp0_, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = secret_schema_new (_tmp4_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	password_schema = _tmp6_;
	_tmp7_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	attributes = _tmp7_;
	_tmp8_ = attributes;
	_tmp9_ = g_strdup ("number");
	_tmp10_ = g_strdup ("8");
	g_hash_table_insert (_tmp8_, _tmp9_, _tmp10_);
	_tmp11_ = attributes;
	_tmp12_ = g_strdup ("string");
	_tmp13_ = g_strdup ("eight");
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp13_);
	_tmp14_ = attributes;
	_tmp15_ = g_strdup ("even");
	_tmp16_ = g_strdup ("true");
	g_hash_table_insert (_tmp14_, _tmp15_, _tmp16_);
	{
		SecretSchema* _tmp17_;
		_tmp17_ = password_schema;
		secret_password_clear_sync (_tmp17_, NULL, &_inner_error_, "number", 8, "string", "eight", "even", TRUE, NULL);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch20_g_error;
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		g_print ("%s", _tmp19_);
		_g_error_free0 (e);
		_g_hash_table_unref0 (attributes);
		_secret_schema_unref0 (password_schema);
		return;
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_hash_table_unref0 (attributes);
		_secret_schema_unref0 (password_schema);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp20_ = password_schema;
	_tmp21_ = attributes;
	_tmp22_ = user;
	_tmp23_ = server_address;
	_tmp24_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s", _tmp22_, _tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = password;
	secret_password_storev (_tmp20_, _tmp21_, SECRET_COLLECTION_DEFAULT, _tmp25_, _tmp26_, NULL, ___lambda6__gasync_ready_callback, NULL);
	_g_free0 (_tmp25_);
	_g_hash_table_unref0 (attributes);
	_secret_schema_unref0 (password_schema);
}


void utils_get_pointer_position (gint* x, gint* y) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkDisplay* gdk_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkSeat* seat = NULL;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	GdkDevice* device = NULL;
	GdkDevice* _tmp4_;
	GdkDevice* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_display = _tmp1_;
	_tmp2_ = gdk_display_get_default_seat (gdk_display);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	seat = _tmp3_;
	_tmp4_ = gdk_seat_get_pointer (seat);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	device = _tmp5_;
	gdk_device_get_position (device, NULL, &_tmp6_, &_tmp7_);
	_vala_x = _tmp6_;
	_vala_y = _tmp7_;
	_g_object_unref0 (device);
	_g_object_unref0 (seat);
	_g_object_unref0 (gdk_display);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}


gboolean utils_pointer_in_widget_area (GtkWidget* widget) {
	gboolean result = FALSE;
	gint pointer_x = 0;
	gint pointer_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkAllocation widget_rect = {0};
	GtkWidget* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gint window_x = 0;
	gint window_y = 0;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GdkWindow* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
	gint _tmp15_;
	g_return_val_if_fail (widget != NULL, FALSE);
	utils_get_pointer_position (&_tmp0_, &_tmp1_);
	pointer_x = _tmp0_;
	pointer_y = _tmp1_;
	_tmp2_ = widget;
	utils_get_origin_allocation (_tmp2_, &_tmp3_);
	widget_rect = _tmp3_;
	_tmp4_ = widget;
	_tmp5_ = gtk_widget_get_toplevel (_tmp4_);
	_tmp6_ = gtk_widget_get_window (_tmp5_);
	gdk_window_get_root_origin (_tmp6_, &_tmp7_, &_tmp8_);
	window_x = _tmp7_;
	window_y = _tmp8_;
	_tmp12_ = pointer_x;
	_tmp13_ = window_x;
	_tmp14_ = widget_rect;
	_tmp15_ = _tmp14_.x;
	if (_tmp12_ > (_tmp13_ + _tmp15_)) {
		gint _tmp16_;
		gint _tmp17_;
		GtkAllocation _tmp18_;
		gint _tmp19_;
		GtkAllocation _tmp20_;
		gint _tmp21_;
		_tmp16_ = pointer_x;
		_tmp17_ = window_x;
		_tmp18_ = widget_rect;
		_tmp19_ = _tmp18_.x;
		_tmp20_ = widget_rect;
		_tmp21_ = _tmp20_.width;
		_tmp11_ = _tmp16_ < ((_tmp17_ + _tmp19_) + _tmp21_);
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		gint _tmp22_;
		gint _tmp23_;
		GtkAllocation _tmp24_;
		gint _tmp25_;
		_tmp22_ = pointer_y;
		_tmp23_ = window_y;
		_tmp24_ = widget_rect;
		_tmp25_ = _tmp24_.y;
		_tmp10_ = _tmp22_ > (_tmp23_ + _tmp25_);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		gint _tmp26_;
		gint _tmp27_;
		GtkAllocation _tmp28_;
		gint _tmp29_;
		GtkAllocation _tmp30_;
		gint _tmp31_;
		_tmp26_ = pointer_y;
		_tmp27_ = window_y;
		_tmp28_ = widget_rect;
		_tmp29_ = _tmp28_.y;
		_tmp30_ = widget_rect;
		_tmp31_ = _tmp30_.height;
		_tmp9_ = _tmp26_ < ((_tmp27_ + _tmp29_) + _tmp31_);
	} else {
		_tmp9_ = FALSE;
	}
	result = _tmp9_;
	return result;
}


void utils_show_manual (void) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	_tmp0_ = utils_is_command_exist ("dman");
	if (_tmp0_) {
		{
			GAppInfo* appinfo = NULL;
			GAppInfo* _tmp1_;
			GAppInfo* _tmp2_;
			_tmp1_ = g_app_info_create_from_commandline ("dman deepin-terminal", NULL, G_APP_INFO_CREATE_NONE, &_inner_error_);
			appinfo = _tmp1_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch22_g_error;
			}
			_tmp2_ = appinfo;
			g_app_info_launch (_tmp2_, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (appinfo);
				goto __catch22_g_error;
			}
			_g_object_unref0 (appinfo);
		}
		goto __finally22;
		__catch22_g_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = e;
			_tmp4_ = _tmp3_->message;
			g_print ("Appbar menu item 'help': %s\n", _tmp4_);
			_g_error_free0 (e);
		}
		__finally22:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void utils_write_log (const gchar* log) {
	gchar* log_file_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* log_file = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (log != NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", NULL);
	log_file_dir = _tmp1_;
	_tmp2_ = g_get_user_cache_dir ();
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "deepin", "deepin-terminal", "deepin-terminal.log", NULL);
	log_file = _tmp3_;
	utils_touch_dir (log_file_dir);
	{
		const gchar* _tmp4_;
		_tmp4_ = log;
		g_file_set_contents (log_file, _tmp4_, (gssize) -1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch23_g_error;
		}
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_print ("write_log: %s\n", _tmp6_);
		_g_error_free0 (e);
	}
	__finally23:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (log_file);
		_g_free0 (log_file_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (log_file);
	_g_free0 (log_file_dir);
}


cairo_surface_t* utils_create_image_surface (const gchar* surface_path) {
	cairo_surface_t* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (surface_path != NULL, NULL);
	_tmp0_ = surface_path;
	_tmp1_ = utils_get_image_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = cairo_image_surface_create_from_png (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gint utils_get_active_monitor (GdkScreen* screen) {
	gint result = 0;
	GdkWindow* window = NULL;
	GdkScreen* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	g_return_val_if_fail (screen != NULL, 0);
	_tmp0_ = screen;
	_tmp1_ = gdk_screen_get_active_window (_tmp0_);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ != NULL) {
		GdkScreen* _tmp3_;
		GdkWindow* _tmp4_;
		gint _tmp5_;
		_tmp3_ = screen;
		_tmp4_ = window;
		_tmp5_ = gdk_screen_get_monitor_at_window (_tmp3_, _tmp4_);
		result = _tmp5_;
		_g_object_unref0 (window);
		return result;
	} else {
		GdkScreen* _tmp6_;
		gint _tmp7_;
		_tmp6_ = screen;
		_tmp7_ = gdk_screen_get_primary_monitor (_tmp6_);
		result = _tmp7_;
		_g_object_unref0 (window);
		return result;
	}
	_g_object_unref0 (window);
}


gint utils_get_pointer_monitor (GdkScreen* screen) {
	gint result = 0;
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkScreen* _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (screen != NULL, 0);
	utils_get_pointer_position (&_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_monitor_at_point (_tmp2_, x, y);
	result = _tmp3_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



