/* progressbar.c generated by valac 0.36.4, the Vala compiler
 * generated from progressbar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2016 Deepin, Inc.
 *               2011 ~ 2016 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define WIDGETS_TYPE_PROGRESS_BAR (widgets_progress_bar_get_type ())
#define WIDGETS_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_PROGRESS_BAR, WidgetsProgressBar))
#define WIDGETS_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_PROGRESS_BAR, WidgetsProgressBarClass))
#define WIDGETS_IS_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_PROGRESS_BAR))
#define WIDGETS_IS_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_PROGRESS_BAR))
#define WIDGETS_PROGRESS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_PROGRESS_BAR, WidgetsProgressBarClass))

typedef struct _WidgetsProgressBar WidgetsProgressBar;
typedef struct _WidgetsProgressBarClass WidgetsProgressBarClass;
typedef struct _WidgetsProgressBarPrivate WidgetsProgressBarPrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	WIDGETS_PROGRESS_BAR_UPDATE_SIGNAL,
	WIDGETS_PROGRESS_BAR_LAST_SIGNAL
};
static guint widgets_progress_bar_signals[WIDGETS_PROGRESS_BAR_LAST_SIGNAL] = {0};

struct _WidgetsProgressBar {
	GtkEventBox parent_instance;
	WidgetsProgressBarPrivate * priv;
	gdouble percent;
	gdouble draw_percent;
	gint height;
	cairo_surface_t* pointer_surface;
	GdkRGBA background_color;
	GdkRGBA foreground_color;
	gint draw_pointer_offset;
	gint line_height;
	gint line_margin_top;
	gint width;
};

struct _WidgetsProgressBarClass {
	GtkEventBoxClass parent_class;
};


static gpointer widgets_progress_bar_parent_class = NULL;
extern gint constant_PREFERENCE_WIDGET_WIDTH;
extern gdouble constant_TERMINAL_MIN_OPACITY;

GType widgets_progress_bar_get_type (void) G_GNUC_CONST;
enum  {
	WIDGETS_PROGRESS_BAR_DUMMY_PROPERTY
};
WidgetsProgressBar* widgets_progress_bar_new (gdouble init_percent);
WidgetsProgressBar* widgets_progress_bar_construct (GType object_type, gdouble init_percent);
void utils_hex_to_rgba (const gchar* hex_color, gdouble alpha, GdkRGBA* result);
cairo_surface_t* utils_create_image_surface (const gchar* surface_path);
static gboolean __lambda165_ (WidgetsProgressBar* self, GtkWidget* w, GdkEventButton* e);
void widgets_progress_bar_set_percent (WidgetsProgressBar* self, gdouble new_percent);
static gboolean ___lambda165__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean __lambda166_ (WidgetsProgressBar* self, GtkWidget* w, GdkEventMotion* e);
static gboolean ___lambda166__gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean widgets_progress_bar_on_draw (WidgetsProgressBar* self, GtkWidget* widget, cairo_t* cr);
static gboolean _widgets_progress_bar_on_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
void utils_set_context_color (cairo_t* cr, GdkRGBA* color);
void draw_draw_rectangle (cairo_t* cr, gint x, gint y, gint w, gint h, gboolean fill);
void draw_draw_surface (cairo_t* cr, cairo_surface_t* surface, gint x, gint y, gint width, gint height);
static void widgets_progress_bar_finalize (GObject * obj);


static gboolean __lambda165_ (WidgetsProgressBar* self, GtkWidget* w, GdkEventButton* e) {
	gboolean result = FALSE;
	GtkAllocation rect = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GdkEventButton* _tmp2_;
	gdouble _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (w != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = w;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	rect = _tmp1_;
	_tmp2_ = e;
	_tmp3_ = _tmp2_->x;
	_tmp4_ = rect;
	_tmp5_ = _tmp4_.width;
	widgets_progress_bar_set_percent (self, (_tmp3_ * 1.0) / _tmp5_);
	result = FALSE;
	return result;
}


static gboolean ___lambda165__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda165_ ((WidgetsProgressBar*) self, _sender, event);
	return result;
}


static gboolean __lambda166_ (WidgetsProgressBar* self, GtkWidget* w, GdkEventMotion* e) {
	gboolean result = FALSE;
	GtkAllocation rect = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GdkEventMotion* _tmp2_;
	gdouble _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (w != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = w;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	rect = _tmp1_;
	_tmp2_ = e;
	_tmp3_ = _tmp2_->x;
	_tmp4_ = rect;
	_tmp5_ = _tmp4_.width;
	widgets_progress_bar_set_percent (self, (_tmp3_ * 1.0) / _tmp5_);
	result = FALSE;
	return result;
}


static gboolean ___lambda166__gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = __lambda166_ ((WidgetsProgressBar*) self, _sender, event);
	return result;
}


static gboolean _widgets_progress_bar_on_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = widgets_progress_bar_on_draw ((WidgetsProgressBar*) self, _sender, cr);
	return result;
}


WidgetsProgressBar* widgets_progress_bar_construct (GType object_type, gdouble init_percent) {
	WidgetsProgressBar * self = NULL;
	gdouble _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_ = {0};
	cairo_surface_t* _tmp5_;
	self = (WidgetsProgressBar*) g_object_new (object_type, NULL);
	_tmp0_ = init_percent;
	self->percent = _tmp0_;
	_tmp1_ = self->width;
	_tmp2_ = self->height;
	gtk_widget_set_size_request ((GtkWidget*) self, _tmp1_, _tmp2_);
	utils_hex_to_rgba ("#2ca7f8", 1.0, &_tmp3_);
	self->foreground_color = _tmp3_;
	utils_hex_to_rgba ("#A4A4A4", 1.0, &_tmp4_);
	self->background_color = _tmp4_;
	_tmp5_ = utils_create_image_surface ("progress_pointer.png");
	_cairo_surface_destroy0 (self->pointer_surface);
	self->pointer_surface = _tmp5_;
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) ___lambda165__gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) ___lambda166__gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _widgets_progress_bar_on_draw_gtk_widget_draw, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}


WidgetsProgressBar* widgets_progress_bar_new (gdouble init_percent) {
	return widgets_progress_bar_construct (WIDGETS_TYPE_PROGRESS_BAR, init_percent);
}


void widgets_progress_bar_set_percent (WidgetsProgressBar* self, gdouble new_percent) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = constant_TERMINAL_MIN_OPACITY;
	_tmp1_ = new_percent;
	_tmp2_ = constant_TERMINAL_MIN_OPACITY;
	_tmp3_ = MIN (((1 - _tmp0_) * _tmp1_) + _tmp2_, (gdouble) 1);
	_tmp4_ = constant_TERMINAL_MIN_OPACITY;
	_tmp5_ = MAX (_tmp3_, _tmp4_);
	self->percent = _tmp5_;
	_tmp6_ = new_percent;
	_tmp7_ = MIN (_tmp6_, (gdouble) 1);
	_tmp8_ = MAX (_tmp7_, (gdouble) 0);
	self->draw_percent = _tmp8_;
	_tmp9_ = self->percent;
	g_signal_emit (self, widgets_progress_bar_signals[WIDGETS_PROGRESS_BAR_UPDATE_SIGNAL], 0, _tmp9_);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static gboolean widgets_progress_bar_on_draw (WidgetsProgressBar* self, GtkWidget* widget, cairo_t* cr) {
	gboolean result = FALSE;
	GtkAllocation rect = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	gint left_offset = 0;
	gint right_offset = 0;
	gdouble _tmp2_;
	cairo_t* _tmp9_;
	GdkRGBA _tmp10_;
	cairo_t* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gdouble _tmp18_;
	cairo_t* _tmp30_;
	cairo_surface_t* _tmp31_;
	gint _tmp32_;
	GtkAllocation _tmp33_;
	gint _tmp34_;
	gdouble _tmp35_;
	cairo_surface_t* _tmp36_;
	gint _tmp37_;
	GtkAllocation _tmp38_;
	gint _tmp39_;
	cairo_surface_t* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = widget;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	rect = _tmp1_;
	left_offset = 0;
	right_offset = 0;
	_tmp2_ = self->draw_percent;
	if (_tmp2_ == ((gdouble) 0)) {
		cairo_surface_t* _tmp3_;
		gint _tmp4_;
		cairo_surface_t* _tmp5_;
		gint _tmp6_;
		_tmp3_ = self->pointer_surface;
		_tmp4_ = cairo_image_surface_get_width (_tmp3_);
		left_offset = _tmp4_ / 2;
		_tmp5_ = self->pointer_surface;
		_tmp6_ = cairo_image_surface_get_width (_tmp5_);
		right_offset = _tmp6_ / 2;
	} else {
		gdouble _tmp7_;
		_tmp7_ = self->draw_percent;
		if (_tmp7_ == ((gdouble) 1)) {
			gint _tmp8_;
			left_offset = 0;
			_tmp8_ = self->draw_pointer_offset;
			right_offset = _tmp8_;
		}
	}
	_tmp9_ = cr;
	_tmp10_ = self->background_color;
	utils_set_context_color (_tmp9_, &_tmp10_);
	_tmp11_ = cr;
	_tmp12_ = left_offset;
	_tmp13_ = self->line_margin_top;
	_tmp14_ = rect;
	_tmp15_ = _tmp14_.width;
	_tmp16_ = right_offset;
	_tmp17_ = self->line_height;
	draw_draw_rectangle (_tmp11_, _tmp12_, _tmp13_, _tmp15_ - _tmp16_, _tmp17_, TRUE);
	_tmp18_ = self->draw_percent;
	if (_tmp18_ > ((gdouble) 0)) {
		cairo_t* _tmp19_;
		cairo_t* _tmp20_;
		GdkRGBA _tmp21_;
		cairo_t* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		GtkAllocation _tmp25_;
		gint _tmp26_;
		gdouble _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		_tmp19_ = cr;
		cairo_set_source_rgba (_tmp19_, (gdouble) 1, (gdouble) 0, (gdouble) 1, (gdouble) 1);
		_tmp20_ = cr;
		_tmp21_ = self->foreground_color;
		utils_set_context_color (_tmp20_, &_tmp21_);
		_tmp22_ = cr;
		_tmp23_ = left_offset;
		_tmp24_ = self->line_margin_top;
		_tmp25_ = rect;
		_tmp26_ = _tmp25_.width;
		_tmp27_ = self->draw_percent;
		_tmp28_ = right_offset;
		_tmp29_ = self->line_height;
		draw_draw_rectangle (_tmp22_, _tmp23_, _tmp24_, ((gint) (_tmp26_ * _tmp27_)) - _tmp28_, _tmp29_, TRUE);
	}
	_tmp30_ = cr;
	_tmp31_ = self->pointer_surface;
	_tmp32_ = self->draw_pointer_offset;
	_tmp33_ = rect;
	_tmp34_ = _tmp33_.width;
	_tmp35_ = self->draw_percent;
	_tmp36_ = self->pointer_surface;
	_tmp37_ = cairo_image_surface_get_width (_tmp36_);
	_tmp38_ = rect;
	_tmp39_ = _tmp38_.width;
	_tmp40_ = self->pointer_surface;
	_tmp41_ = cairo_image_surface_get_width (_tmp40_);
	_tmp42_ = self->draw_pointer_offset;
	_tmp43_ = MIN (((gint) (_tmp34_ * _tmp35_)) - (_tmp37_ / 2), (_tmp39_ - _tmp41_) + _tmp42_);
	_tmp44_ = MAX (-_tmp32_, _tmp43_);
	draw_draw_surface (_tmp30_, _tmp31_, _tmp44_, 0, 0, 0);
	result = TRUE;
	return result;
}


static void widgets_progress_bar_class_init (WidgetsProgressBarClass * klass) {
	widgets_progress_bar_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = widgets_progress_bar_finalize;
	widgets_progress_bar_signals[WIDGETS_PROGRESS_BAR_UPDATE_SIGNAL] = g_signal_new ("update", WIDGETS_TYPE_PROGRESS_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
}


static void widgets_progress_bar_instance_init (WidgetsProgressBar * self) {
	gint _tmp0_;
	self->height = 22;
	self->draw_pointer_offset = 3;
	self->line_height = 2;
	self->line_margin_top = 10;
	_tmp0_ = constant_PREFERENCE_WIDGET_WIDTH;
	self->width = _tmp0_;
}


static void widgets_progress_bar_finalize (GObject * obj) {
	WidgetsProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_PROGRESS_BAR, WidgetsProgressBar);
	_cairo_surface_destroy0 (self->pointer_surface);
	G_OBJECT_CLASS (widgets_progress_bar_parent_class)->finalize (obj);
}


GType widgets_progress_bar_get_type (void) {
	static volatile gsize widgets_progress_bar_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_progress_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WidgetsProgressBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_progress_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsProgressBar), 0, (GInstanceInitFunc) widgets_progress_bar_instance_init, NULL };
		GType widgets_progress_bar_type_id;
		widgets_progress_bar_type_id = g_type_register_static (gtk_event_box_get_type (), "WidgetsProgressBar", &g_define_type_info, 0);
		g_once_init_leave (&widgets_progress_bar_type_id__volatile, widgets_progress_bar_type_id);
	}
	return widgets_progress_bar_type_id__volatile;
}



