/* theme_button.c generated by valac 0.36.4, the Vala compiler
 * generated from theme_button.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2016 Deepin, Inc.
 *               2011 ~ 2016 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gee.h>


#define WIDGETS_TYPE_THEME_BUTTON (widgets_theme_button_get_type ())
#define WIDGETS_THEME_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_THEME_BUTTON, WidgetsThemeButton))
#define WIDGETS_THEME_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_THEME_BUTTON, WidgetsThemeButtonClass))
#define WIDGETS_IS_THEME_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_THEME_BUTTON))
#define WIDGETS_IS_THEME_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_THEME_BUTTON))
#define WIDGETS_THEME_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_THEME_BUTTON, WidgetsThemeButtonClass))

typedef struct _WidgetsThemeButton WidgetsThemeButton;
typedef struct _WidgetsThemeButtonClass WidgetsThemeButtonClass;
typedef struct _WidgetsThemeButtonPrivate WidgetsThemeButtonPrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define WIDGETS_TYPE_THEME_LIST (widgets_theme_list_get_type ())
#define WIDGETS_THEME_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_THEME_LIST, WidgetsThemeList))
#define WIDGETS_THEME_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_THEME_LIST, WidgetsThemeListClass))
#define WIDGETS_IS_THEME_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_THEME_LIST))
#define WIDGETS_IS_THEME_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_THEME_LIST))
#define WIDGETS_THEME_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_THEME_LIST, WidgetsThemeListClass))

typedef struct _WidgetsThemeList WidgetsThemeList;
typedef struct _WidgetsThemeListClass WidgetsThemeListClass;
typedef struct _WidgetsThemeListPrivate WidgetsThemeListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block40Data Block40Data;
enum  {
	WIDGETS_THEME_LIST_ACTIVE_THEME_SIGNAL,
	WIDGETS_THEME_LIST_LAST_SIGNAL
};
static guint widgets_theme_list_signals[WIDGETS_THEME_LIST_LAST_SIGNAL] = {0};

struct _WidgetsThemeButton {
	GtkEventBox parent_instance;
	WidgetsThemeButtonPrivate * priv;
	GdkRGBA background_color;
	GdkRGBA content_color;
	GdkRGBA foreground_color;
	cairo_surface_t* dark_theme_border_surface;
	cairo_surface_t* light_theme_border_surface;
	cairo_surface_t* active_theme_border_surface;
	GKeyFile* theme_file;
	gboolean is_active;
	gboolean is_light_color;
	gint button_radius;
	gint content_font_size;
	gint content_padding_x;
	gint content_padding_y;
	gint title_font_size;
	gint title_padding_x;
	gint title_padding_y;
	gint background_padding;
	gint border_padding;
	gchar* theme_name;
};

struct _WidgetsThemeButtonClass {
	GtkEventBoxClass parent_class;
};

struct _WidgetsThemeList {
	GtkVBox parent_instance;
	WidgetsThemeListPrivate * priv;
	gint theme_button_padding;
	GeeHashMap* theme_button_map;
	WidgetsThemeButton* active_theme_button;
};

struct _WidgetsThemeListClass {
	GtkVBoxClass parent_class;
};

struct _Block40Data {
	int _ref_count_;
	WidgetsThemeList* self;
	gchar* theme_name;
};


static gpointer widgets_theme_button_parent_class = NULL;
extern gint constant_THEME_BUTTON_WIDTH;
extern gint constant_THEME_BUTTON_HEIGHT;
extern gint constant_THEME_SLIDER_WIDTH;
static gpointer widgets_theme_list_parent_class = NULL;
extern gint constant_THEME_BUTTON_PADDING;

GType widgets_theme_button_get_type (void) G_GNUC_CONST;
enum  {
	WIDGETS_THEME_BUTTON_DUMMY_PROPERTY
};
WidgetsThemeButton* widgets_theme_button_new (const gchar* name);
WidgetsThemeButton* widgets_theme_button_construct (GType object_type, const gchar* name);
gchar* utils_get_theme_path (const gchar* theme_name);
void utils_hex_to_rgba (const gchar* hex_color, gdouble alpha, GdkRGBA* result);
gboolean utils_is_light_color (const gchar* color_string);
cairo_surface_t* utils_create_image_surface (const gchar* surface_path);
static gboolean widgets_theme_button_on_draw (WidgetsThemeButton* self, GtkWidget* widget, cairo_t* cr);
static gboolean _widgets_theme_button_on_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
void widgets_theme_button_active (WidgetsThemeButton* self);
void widgets_theme_button_inactive (WidgetsThemeButton* self);
void draw_fill_rounded_rectangle (cairo_t* cr, gint x, gint y, gint width, gint height, gdouble r);
void draw_draw_text (cairo_t* cr, const gchar* text, gint x, gint y, gint width, gint height, gint size, PangoAlignment horizontal_alignment, const gchar* vertical_align, gint* wrap_width);
void draw_draw_surface (cairo_t* cr, cairo_surface_t* surface, gint x, gint y, gint width, gint height);
static void widgets_theme_button_finalize (GObject * obj);
GType widgets_theme_list_get_type (void) G_GNUC_CONST;
enum  {
	WIDGETS_THEME_LIST_DUMMY_PROPERTY
};
WidgetsThemeList* widgets_theme_list_new (const gchar* default_theme);
WidgetsThemeList* widgets_theme_list_construct (GType object_type, const gchar* default_theme);
GeeArrayList* utils_list_files (const gchar* path);
gchar* utils_get_theme_dir (void);
gint widgets_theme_list_compare_color_brightness (const gchar* a, const gchar* b);
static Block40Data* block40_data_ref (Block40Data* _data40_);
static void block40_data_unref (void * _userdata_);
static gboolean ____lambda69_ (Block40Data* _data40_, GtkWidget* w, GdkEventButton* e);
gboolean utils_is_left_button (GdkEventButton* event);
void widgets_theme_list_active_button (WidgetsThemeList* self, const gchar* theme_name);
static gboolean _____lambda69__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
gdouble utils_get_color_brightness (const gchar* color_string);
static void widgets_theme_list_finalize (GObject * obj);


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static gboolean _widgets_theme_button_on_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = widgets_theme_button_on_draw ((WidgetsThemeButton*) self, _sender, cr);
	return result;
}


WidgetsThemeButton* widgets_theme_button_construct (GType object_type, const gchar* name) {
	WidgetsThemeButton * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (WidgetsThemeButton*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->theme_name);
	self->theme_name = _tmp1_;
	{
		GKeyFile* _tmp2_;
		GKeyFile* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GKeyFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GdkRGBA _tmp14_ = {0};
		gchar* _tmp15_ = NULL;
		GKeyFile* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
		gchar* _tmp23_ = NULL;
		GKeyFile* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GdkRGBA _tmp30_ = {0};
		gchar* _tmp31_ = NULL;
		GKeyFile* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GdkRGBA _tmp38_ = {0};
		cairo_surface_t* _tmp39_;
		cairo_surface_t* _tmp40_;
		cairo_surface_t* _tmp41_;
		_tmp2_ = g_key_file_new ();
		_g_key_file_unref0 (self->theme_file);
		self->theme_file = _tmp2_;
		_tmp3_ = self->theme_file;
		_tmp4_ = self->theme_name;
		_tmp5_ = utils_get_theme_path (_tmp4_);
		_tmp6_ = _tmp5_;
		g_key_file_load_from_file (_tmp3_, _tmp6_, G_KEY_FILE_NONE, &_inner_error_);
		_g_free0 (_tmp6_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch94_g_error;
		}
		_tmp8_ = self->theme_file;
		_tmp9_ = g_key_file_get_string (_tmp8_, "theme", "background", &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch94_g_error;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		_tmp11_ = _tmp10_;
		_tmp12_ = string_strip (_tmp11_);
		_tmp13_ = _tmp12_;
		utils_hex_to_rgba (_tmp13_, 1.0, &_tmp14_);
		self->background_color = _tmp14_;
		_g_free0 (_tmp13_);
		_g_free0 (_tmp11_);
		_tmp16_ = self->theme_file;
		_tmp17_ = g_key_file_get_string (_tmp16_, "theme", "background", &_inner_error_);
		_tmp15_ = _tmp17_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (_tmp7_);
			goto __catch94_g_error;
		}
		_tmp18_ = _tmp15_;
		_tmp15_ = NULL;
		_tmp19_ = _tmp18_;
		_tmp20_ = string_strip (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = utils_is_light_color (_tmp21_);
		self->is_light_color = _tmp22_;
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		self->background_color.alpha = 0.8;
		_tmp24_ = self->theme_file;
		_tmp25_ = g_key_file_get_string (_tmp24_, "theme", "foreground", &_inner_error_);
		_tmp23_ = _tmp25_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (_tmp15_);
			_g_free0 (_tmp7_);
			goto __catch94_g_error;
		}
		_tmp26_ = _tmp23_;
		_tmp23_ = NULL;
		_tmp27_ = _tmp26_;
		_tmp28_ = string_strip (_tmp27_);
		_tmp29_ = _tmp28_;
		utils_hex_to_rgba (_tmp29_, 1.0, &_tmp30_);
		self->foreground_color = _tmp30_;
		_g_free0 (_tmp29_);
		_g_free0 (_tmp27_);
		_tmp32_ = self->theme_file;
		_tmp33_ = g_key_file_get_string (_tmp32_, "theme", "color_2", &_inner_error_);
		_tmp31_ = _tmp33_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (_tmp23_);
			_g_free0 (_tmp15_);
			_g_free0 (_tmp7_);
			goto __catch94_g_error;
		}
		_tmp34_ = _tmp31_;
		_tmp31_ = NULL;
		_tmp35_ = _tmp34_;
		_tmp36_ = string_strip (_tmp35_);
		_tmp37_ = _tmp36_;
		utils_hex_to_rgba (_tmp37_, 1.0, &_tmp38_);
		self->content_color = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		_tmp39_ = utils_create_image_surface ("dark_theme_border.png");
		_cairo_surface_destroy0 (self->dark_theme_border_surface);
		self->dark_theme_border_surface = _tmp39_;
		_tmp40_ = utils_create_image_surface ("light_theme_border.png");
		_cairo_surface_destroy0 (self->light_theme_border_surface);
		self->light_theme_border_surface = _tmp40_;
		_tmp41_ = utils_create_image_surface ("active_theme_border.png");
		_cairo_surface_destroy0 (self->active_theme_border_surface);
		self->active_theme_border_surface = _tmp41_;
		_g_free0 (_tmp31_);
		_g_free0 (_tmp23_);
		_g_free0 (_tmp15_);
		_g_free0 (_tmp7_);
	}
	goto __finally94;
	__catch94_g_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp42_ = e;
		_tmp43_ = _tmp42_->message;
		g_print ("ThemeButton: %s\n", _tmp43_);
		_g_error_free0 (e);
	}
	__finally94:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
	_tmp44_ = constant_THEME_BUTTON_WIDTH;
	_tmp45_ = constant_THEME_BUTTON_HEIGHT;
	gtk_widget_set_size_request ((GtkWidget*) self, _tmp44_, _tmp45_);
	_tmp46_ = constant_THEME_SLIDER_WIDTH;
	_tmp47_ = constant_THEME_BUTTON_WIDTH;
	gtk_widget_set_margin_start ((GtkWidget*) self, (_tmp46_ - _tmp47_) / 2);
	_tmp48_ = constant_THEME_SLIDER_WIDTH;
	_tmp49_ = constant_THEME_BUTTON_WIDTH;
	gtk_widget_set_margin_end ((GtkWidget*) self, (_tmp48_ - _tmp49_) / 2);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _widgets_theme_button_on_draw_gtk_widget_draw, self, 0);
	return self;
}


WidgetsThemeButton* widgets_theme_button_new (const gchar* name) {
	return widgets_theme_button_construct (WIDGETS_TYPE_THEME_BUTTON, name);
}


void widgets_theme_button_active (WidgetsThemeButton* self) {
	g_return_if_fail (self != NULL);
	self->is_active = TRUE;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void widgets_theme_button_inactive (WidgetsThemeButton* self) {
	g_return_if_fail (self != NULL);
	self->is_active = FALSE;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static gboolean widgets_theme_button_on_draw (WidgetsThemeButton* self, GtkWidget* widget, cairo_t* cr) {
	gboolean result = FALSE;
	GtkAllocation rect = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	cairo_t* _tmp2_;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
	GdkRGBA _tmp9_;
	gdouble _tmp10_;
	cairo_t* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GtkAllocation _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	cairo_t* _tmp21_;
	GdkRGBA _tmp22_;
	gdouble _tmp23_;
	GdkRGBA _tmp24_;
	gdouble _tmp25_;
	GdkRGBA _tmp26_;
	gdouble _tmp27_;
	GdkRGBA _tmp28_;
	gdouble _tmp29_;
	cairo_t* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GtkAllocation _tmp33_;
	gint _tmp34_;
	GtkAllocation _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	cairo_t* _tmp38_;
	GdkRGBA _tmp39_;
	gdouble _tmp40_;
	GdkRGBA _tmp41_;
	gdouble _tmp42_;
	GdkRGBA _tmp43_;
	gdouble _tmp44_;
	GdkRGBA _tmp45_;
	gdouble _tmp46_;
	cairo_t* _tmp47_;
	const gchar* _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	GtkAllocation _tmp51_;
	gint _tmp52_;
	GtkAllocation _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gboolean _tmp56_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = widget;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	rect = _tmp1_;
	_tmp2_ = cr;
	_tmp3_ = self->background_color;
	_tmp4_ = _tmp3_.red;
	_tmp5_ = self->background_color;
	_tmp6_ = _tmp5_.green;
	_tmp7_ = self->background_color;
	_tmp8_ = _tmp7_.blue;
	_tmp9_ = self->background_color;
	_tmp10_ = _tmp9_.alpha;
	cairo_set_source_rgba (_tmp2_, _tmp4_, _tmp6_, _tmp8_, _tmp10_);
	_tmp11_ = cr;
	_tmp12_ = self->background_padding;
	_tmp13_ = self->background_padding;
	_tmp14_ = rect;
	_tmp15_ = _tmp14_.width;
	_tmp16_ = self->background_padding;
	_tmp17_ = rect;
	_tmp18_ = _tmp17_.height;
	_tmp19_ = self->background_padding;
	_tmp20_ = self->button_radius;
	draw_fill_rounded_rectangle (_tmp11_, _tmp12_, _tmp13_, _tmp15_ - (_tmp16_ * 2), _tmp18_ - (_tmp19_ * 2), (gdouble) _tmp20_);
	_tmp21_ = cr;
	_tmp22_ = self->foreground_color;
	_tmp23_ = _tmp22_.red;
	_tmp24_ = self->foreground_color;
	_tmp25_ = _tmp24_.green;
	_tmp26_ = self->foreground_color;
	_tmp27_ = _tmp26_.blue;
	_tmp28_ = self->foreground_color;
	_tmp29_ = _tmp28_.alpha;
	cairo_set_source_rgba (_tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp29_);
	_tmp30_ = cr;
	_tmp31_ = self->title_padding_x;
	_tmp32_ = self->title_padding_y;
	_tmp33_ = rect;
	_tmp34_ = _tmp33_.width;
	_tmp35_ = rect;
	_tmp36_ = _tmp35_.height;
	_tmp37_ = self->title_font_size;
	draw_draw_text (_tmp30_, "deepin@linux > _", _tmp31_, _tmp32_, _tmp34_, _tmp36_, _tmp37_, PANGO_ALIGN_LEFT, "top", NULL);
	_tmp38_ = cr;
	_tmp39_ = self->content_color;
	_tmp40_ = _tmp39_.red;
	_tmp41_ = self->content_color;
	_tmp42_ = _tmp41_.green;
	_tmp43_ = self->content_color;
	_tmp44_ = _tmp43_.blue;
	_tmp45_ = self->content_color;
	_tmp46_ = _tmp45_.alpha;
	cairo_set_source_rgba (_tmp38_, _tmp40_, _tmp42_, _tmp44_, _tmp46_);
	_tmp47_ = cr;
	_tmp48_ = self->theme_name;
	_tmp49_ = self->content_padding_x;
	_tmp50_ = self->content_padding_y;
	_tmp51_ = rect;
	_tmp52_ = _tmp51_.width;
	_tmp53_ = rect;
	_tmp54_ = _tmp53_.height;
	_tmp55_ = self->content_font_size;
	draw_draw_text (_tmp47_, _tmp48_, _tmp49_, _tmp50_, _tmp52_, _tmp54_, _tmp55_, PANGO_ALIGN_LEFT, "top", NULL);
	_tmp56_ = self->is_active;
	if (_tmp56_) {
		cairo_t* _tmp57_;
		cairo_surface_t* _tmp58_;
		_tmp57_ = cr;
		_tmp58_ = self->active_theme_border_surface;
		draw_draw_surface (_tmp57_, _tmp58_, 0, 0, 0, 0);
	} else {
		gboolean _tmp59_;
		_tmp59_ = self->is_light_color;
		if (_tmp59_) {
			cairo_t* _tmp60_;
			cairo_surface_t* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			_tmp60_ = cr;
			_tmp61_ = self->light_theme_border_surface;
			_tmp62_ = self->border_padding;
			_tmp63_ = self->border_padding;
			draw_draw_surface (_tmp60_, _tmp61_, _tmp62_, _tmp63_, 0, 0);
		} else {
			cairo_t* _tmp64_;
			cairo_surface_t* _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
			_tmp64_ = cr;
			_tmp65_ = self->dark_theme_border_surface;
			_tmp66_ = self->border_padding;
			_tmp67_ = self->border_padding;
			draw_draw_surface (_tmp64_, _tmp65_, _tmp66_, _tmp67_, 0, 0);
		}
	}
	result = TRUE;
	return result;
}


static void widgets_theme_button_class_init (WidgetsThemeButtonClass * klass) {
	widgets_theme_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = widgets_theme_button_finalize;
}


static void widgets_theme_button_instance_init (WidgetsThemeButton * self) {
	self->is_active = FALSE;
	self->button_radius = 5;
	self->content_font_size = 11;
	self->content_padding_x = 14;
	self->content_padding_y = 25;
	self->title_font_size = 11;
	self->title_padding_x = 14;
	self->title_padding_y = 6;
	self->background_padding = 2;
	self->border_padding = 1;
}


static void widgets_theme_button_finalize (GObject * obj) {
	WidgetsThemeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_THEME_BUTTON, WidgetsThemeButton);
	_cairo_surface_destroy0 (self->dark_theme_border_surface);
	_cairo_surface_destroy0 (self->light_theme_border_surface);
	_cairo_surface_destroy0 (self->active_theme_border_surface);
	_g_key_file_unref0 (self->theme_file);
	_g_free0 (self->theme_name);
	G_OBJECT_CLASS (widgets_theme_button_parent_class)->finalize (obj);
}


GType widgets_theme_button_get_type (void) {
	static volatile gsize widgets_theme_button_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_theme_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WidgetsThemeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_theme_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsThemeButton), 0, (GInstanceInitFunc) widgets_theme_button_instance_init, NULL };
		GType widgets_theme_button_type_id;
		widgets_theme_button_type_id = g_type_register_static (gtk_event_box_get_type (), "WidgetsThemeButton", &g_define_type_info, 0);
		g_once_init_leave (&widgets_theme_button_type_id__volatile, widgets_theme_button_type_id);
	}
	return widgets_theme_button_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block40Data* block40_data_ref (Block40Data* _data40_) {
	g_atomic_int_inc (&_data40_->_ref_count_);
	return _data40_;
}


static void block40_data_unref (void * _userdata_) {
	Block40Data* _data40_;
	_data40_ = (Block40Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data40_->_ref_count_)) {
		WidgetsThemeList* self;
		self = _data40_->self;
		_g_free0 (_data40_->theme_name);
		_g_object_unref0 (self);
		g_slice_free (Block40Data, _data40_);
	}
}


static gboolean ____lambda69_ (Block40Data* _data40_, GtkWidget* w, GdkEventButton* e) {
	WidgetsThemeList* self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	gboolean _tmp1_;
	self = _data40_->self;
	g_return_val_if_fail (w != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e;
	_tmp1_ = utils_is_left_button (_tmp0_);
	if (_tmp1_) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = _data40_->theme_name;
		widgets_theme_list_active_button (self, _tmp2_);
		_tmp3_ = _data40_->theme_name;
		g_signal_emit (self, widgets_theme_list_signals[WIDGETS_THEME_LIST_ACTIVE_THEME_SIGNAL], 0, _tmp3_);
	}
	result = FALSE;
	return result;
}


static gboolean _____lambda69__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = ____lambda69_ (self, _sender, event);
	return result;
}


WidgetsThemeList* widgets_theme_list_construct (GType object_type, const gchar* default_theme) {
	WidgetsThemeList * self = NULL;
	GeeHashMap* _tmp0_;
	GeeArrayList* theme_names = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	const gchar* _tmp25_;
	g_return_val_if_fail (default_theme != NULL, NULL);
	self = (WidgetsThemeList*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WIDGETS_TYPE_THEME_BUTTON, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->theme_button_map);
	self->theme_button_map = _tmp0_;
	_tmp1_ = utils_get_theme_dir ();
	_tmp2_ = _tmp1_;
	_tmp3_ = utils_list_files (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	theme_names = _tmp4_;
	_tmp5_ = theme_names;
	gee_list_sort ((GeeList*) _tmp5_, (GCompareDataFunc) widgets_theme_list_compare_color_brightness, NULL, NULL);
	{
		GeeArrayList* _theme_name_list = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		gint _theme_name_size = 0;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _theme_name_index = 0;
		_tmp6_ = theme_names;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_theme_name_list = _tmp7_;
		_tmp8_ = _theme_name_list;
		_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_theme_name_size = _tmp10_;
		_theme_name_index = -1;
		while (TRUE) {
			Block40Data* _data40_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			GeeArrayList* _tmp14_;
			gint _tmp15_;
			gpointer _tmp16_;
			WidgetsThemeButton* button = NULL;
			const gchar* _tmp17_;
			WidgetsThemeButton* _tmp18_;
			WidgetsThemeButton* _tmp19_;
			gint _tmp20_;
			WidgetsThemeButton* _tmp21_;
			GeeHashMap* _tmp22_;
			const gchar* _tmp23_;
			WidgetsThemeButton* _tmp24_;
			_data40_ = g_slice_new0 (Block40Data);
			_data40_->_ref_count_ = 1;
			_data40_->self = g_object_ref (self);
			_tmp11_ = _theme_name_index;
			_theme_name_index = _tmp11_ + 1;
			_tmp12_ = _theme_name_index;
			_tmp13_ = _theme_name_size;
			if (!(_tmp12_ < _tmp13_)) {
				block40_data_unref (_data40_);
				_data40_ = NULL;
				break;
			}
			_tmp14_ = _theme_name_list;
			_tmp15_ = _theme_name_index;
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _tmp15_);
			_data40_->theme_name = (gchar*) _tmp16_;
			_tmp17_ = _data40_->theme_name;
			_tmp18_ = widgets_theme_button_new (_tmp17_);
			g_object_ref_sink (_tmp18_);
			button = _tmp18_;
			_tmp19_ = button;
			_tmp20_ = self->theme_button_padding;
			gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) _tmp20_);
			_tmp21_ = button;
			g_signal_connect_data ((GtkWidget*) _tmp21_, "button-press-event", (GCallback) _____lambda69__gtk_widget_button_press_event, block40_data_ref (_data40_), (GClosureNotify) block40_data_unref, 0);
			_tmp22_ = self->theme_button_map;
			_tmp23_ = _data40_->theme_name;
			_tmp24_ = button;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, _tmp23_, _tmp24_);
			_g_object_unref0 (button);
			block40_data_unref (_data40_);
			_data40_ = NULL;
		}
		_g_object_unref0 (_theme_name_list);
	}
	_tmp25_ = default_theme;
	widgets_theme_list_active_button (self, _tmp25_);
	_g_object_unref0 (theme_names);
	return self;
}


WidgetsThemeList* widgets_theme_list_new (const gchar* default_theme) {
	return widgets_theme_list_construct (WIDGETS_TYPE_THEME_LIST, default_theme);
}


gint widgets_theme_list_compare_color_brightness (const gchar* a, const gchar* b) {
	gint result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	{
		GKeyFile* a_theme_file = NULL;
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		GKeyFile* _tmp6_;
		gchar* _tmp7_;
		gdouble a_background_color = 0.0;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		GKeyFile* b_theme_file = NULL;
		GKeyFile* _tmp14_;
		GKeyFile* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_ = NULL;
		GKeyFile* _tmp20_;
		gchar* _tmp21_;
		gdouble b_background_color = 0.0;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
		_tmp0_ = g_key_file_new ();
		a_theme_file = _tmp0_;
		_tmp1_ = a_theme_file;
		_tmp2_ = a;
		_tmp3_ = utils_get_theme_path ((const gchar*) _tmp2_);
		_tmp4_ = _tmp3_;
		g_key_file_load_from_file (_tmp1_, _tmp4_, G_KEY_FILE_NONE, &_inner_error_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_key_file_unref0 (a_theme_file);
			goto __catch95_g_error;
		}
		_tmp6_ = a_theme_file;
		_tmp7_ = g_key_file_get_string (_tmp6_, "theme", "background", &_inner_error_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_key_file_unref0 (a_theme_file);
			goto __catch95_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_tmp9_ = _tmp8_;
		_tmp10_ = string_strip (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = utils_get_color_brightness (_tmp11_);
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		a_background_color = _tmp13_;
		_tmp14_ = g_key_file_new ();
		b_theme_file = _tmp14_;
		_tmp15_ = b_theme_file;
		_tmp16_ = b;
		_tmp17_ = utils_get_theme_path ((const gchar*) _tmp16_);
		_tmp18_ = _tmp17_;
		g_key_file_load_from_file (_tmp15_, _tmp18_, G_KEY_FILE_NONE, &_inner_error_);
		_g_free0 (_tmp18_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_key_file_unref0 (b_theme_file);
			_g_free0 (_tmp5_);
			_g_key_file_unref0 (a_theme_file);
			goto __catch95_g_error;
		}
		_tmp20_ = b_theme_file;
		_tmp21_ = g_key_file_get_string (_tmp20_, "theme", "background", &_inner_error_);
		_tmp19_ = _tmp21_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_key_file_unref0 (b_theme_file);
			_g_free0 (_tmp5_);
			_g_key_file_unref0 (a_theme_file);
			goto __catch95_g_error;
		}
		_tmp22_ = _tmp19_;
		_tmp19_ = NULL;
		_tmp23_ = _tmp22_;
		_tmp24_ = string_strip (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = utils_get_color_brightness (_tmp25_);
		_tmp27_ = _tmp26_;
		_g_free0 (_tmp25_);
		_g_free0 (_tmp23_);
		b_background_color = _tmp27_;
		_tmp28_ = a_background_color;
		_tmp29_ = b_background_color;
		if (_tmp28_ > _tmp29_) {
			result = 1;
			_g_free0 (_tmp19_);
			_g_key_file_unref0 (b_theme_file);
			_g_free0 (_tmp5_);
			_g_key_file_unref0 (a_theme_file);
			return result;
		}
		_tmp30_ = a_background_color;
		_tmp31_ = b_background_color;
		if (_tmp30_ == _tmp31_) {
			result = 0;
			_g_free0 (_tmp19_);
			_g_key_file_unref0 (b_theme_file);
			_g_free0 (_tmp5_);
			_g_key_file_unref0 (a_theme_file);
			return result;
		}
		_g_free0 (_tmp19_);
		_g_key_file_unref0 (b_theme_file);
		_g_free0 (_tmp5_);
		_g_key_file_unref0 (a_theme_file);
	}
	goto __finally95;
	__catch95_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		g_print ("compare_color_brightness: %s\n", _tmp33_);
		_g_error_free0 (e);
	}
	__finally95:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp34_ = 0;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp34_;
	}
	result = -1;
	return result;
}


void widgets_theme_list_active_button (WidgetsThemeList* self, const gchar* theme_name) {
	WidgetsThemeButton* _tmp0_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	WidgetsThemeButton* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (theme_name != NULL);
	_tmp0_ = self->active_theme_button;
	if (_tmp0_ != NULL) {
		WidgetsThemeButton* _tmp1_;
		_tmp1_ = self->active_theme_button;
		widgets_theme_button_inactive (_tmp1_);
	}
	_tmp2_ = self->theme_button_map;
	_tmp3_ = theme_name;
	_tmp4_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, _tmp3_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
		gpointer _tmp7_;
		_tmp5_ = self->theme_button_map;
		_tmp6_ = theme_name;
		_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, _tmp6_);
		_g_object_unref0 (self->active_theme_button);
		self->active_theme_button = (WidgetsThemeButton*) _tmp7_;
	} else {
		GeeHashMap* _tmp8_;
		gpointer _tmp9_;
		_tmp8_ = self->theme_button_map;
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, "deepin");
		_g_object_unref0 (self->active_theme_button);
		self->active_theme_button = (WidgetsThemeButton*) _tmp9_;
	}
	_tmp10_ = self->active_theme_button;
	widgets_theme_button_active (_tmp10_);
}


static void widgets_theme_list_class_init (WidgetsThemeListClass * klass) {
	widgets_theme_list_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = widgets_theme_list_finalize;
	widgets_theme_list_signals[WIDGETS_THEME_LIST_ACTIVE_THEME_SIGNAL] = g_signal_new ("active_theme", WIDGETS_TYPE_THEME_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void widgets_theme_list_instance_init (WidgetsThemeList * self) {
	gint _tmp0_;
	_tmp0_ = constant_THEME_BUTTON_PADDING;
	self->theme_button_padding = _tmp0_;
	self->active_theme_button = NULL;
}


static void widgets_theme_list_finalize (GObject * obj) {
	WidgetsThemeList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_THEME_LIST, WidgetsThemeList);
	_g_object_unref0 (self->theme_button_map);
	_g_object_unref0 (self->active_theme_button);
	G_OBJECT_CLASS (widgets_theme_list_parent_class)->finalize (obj);
}


GType widgets_theme_list_get_type (void) {
	static volatile gsize widgets_theme_list_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_theme_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WidgetsThemeListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_theme_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsThemeList), 0, (GInstanceInitFunc) widgets_theme_list_instance_init, NULL };
		GType widgets_theme_list_type_id;
		widgets_theme_list_type_id = g_type_register_static (gtk_vbox_get_type (), "WidgetsThemeList", &g_define_type_info, 0);
		g_once_init_leave (&widgets_theme_list_type_id__volatile, widgets_theme_list_type_id);
	}
	return widgets_theme_list_type_id__volatile;
}



